"use strict";
const React = require("react");
const ael_1 = require("../util/ael");
class WindowEvent extends React.Component {
    constructor() {
        super(...arguments);
        this.eventMap = {};
    }
    updateEventHandler(np) {
        let { ctx } = this.props;
        Object.keys(this.eventMap).forEach(k => {
            if (!np[k]) {
                this.eventMap[k].dispose();
            }
        });
        Object.keys(np).forEach(k => {
            let evt = k.slice(2).toLowerCase();
            if (this.eventMap[k] && this.eventMap[k].handler !== np[k]) {
                this.eventMap[k].dispose();
            }
            this.eventMap[k] = ael_1.ael(ctx, evt, this.props[k]);
        });
    }
    componentDidMount() {
        this.updateEventHandler(this.props);
    }
    componentWillReceiveProps(np) {
        this.updateEventHandler(np);
    }
    componentWillUnmount() {
        Object.keys(this.eventMap).forEach(k => this.eventMap[k].dispose());
    }
    render() { return null; }
}
exports.WindowEvent = WindowEvent;
WindowEvent.defaultProps = {
    ctx: window
};
